#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef struct
{
    char *izvodjac;
    char *naslov;
    int brGledanja;
}pesma;

char tip;

int poredi(const void *a, const void *b)
{
    pesma p1 = *(pesma*)a;
    pesma p2 = *(pesma*)b;
    
    if(tip == 'b')
        return p1.brGledanja - p2.brGledanja;
    else if(tip == 'i')
        return strcmp(p1.izvodjac, p2.izvodjac);
    else if(tip == 'n')
        return strcmp(p1.naslov, p2.naslov);
}

char* ucitaj_nisku(FILE *f)
{
    char c, *r = NULL;
    int n = 0;
    if(feof(f))
        return NULL;
    c = fgetc(f);
    while(c != ' ' && c != EOF)
    {
        if(c == '\n')
        {
            c = fgetc(f);
            continue;
        }
        n++;
        r = realloc(r, sizeof(char) * n);
        if(r == NULL)
        {
            printf("greska");
            exit(EXIT_FAILURE);
        }
        r[n - 1] = c;
        c = fgetc(f);
    }
    n++;
    r = realloc(r, sizeof(char) * n);
    if(r == NULL)
    {
        printf("greska");
        exit(EXIT_FAILURE);
    }
    r[n - 1] = 0;
    return r;
}

int main(int argc, char *argv[])
{
    pesma *pesme;
    FILE *f;
    char pom1[1000], pom2[1000], p[10], *r1, *r2, *r3;
    int pom3, n, i, uspesno_citanje;
    
    f = fopen("pesme.txt", "r");
    if(f == NULL)
    {
        printf("Greska");
        exit(EXIT_FAILURE);
    }
    
    n = 0;
    pesme = NULL;
    uspesno_citanje = 1;
    while(uspesno_citanje)
    {
        r1 = ucitaj_nisku(f);
        r2 = ucitaj_nisku(f);
        r3 = ucitaj_nisku(f);
        
        if(r1 == NULL || r2 == NULL
            || r3 == NULL 
            || fscanf(f, "%d", &pom3) != 1)
        {
            uspesno_citanje = 0;
            continue;
        }
        
        n++;
        pesme = (pesma*)realloc(pesme, n * sizeof(pesma));
        if(pesme == NULL)
        {
            printf("Greska");
            exit(EXIT_FAILURE);
        }
        r3[strlen(r3) - 1] = 0;
        
        pesme[n - 1].brGledanja = pom3;
        pesme[n - 1].izvodjac 
            = (char*)malloc((strlen(r1) + 1) * sizeof(char));
        pesme[n - 1].naslov 
            = (char*)malloc((strlen(r3) + 1) * sizeof(char));
        if(pesme[n - 1].izvodjac == NULL
            || pesme[n - 1].naslov == NULL)
        {
            printf("Greska");
            exit(EXIT_FAILURE);            
        }
        strcpy(pesme[n - 1].izvodjac, r1);
        strcpy(pesme[n - 1].naslov, r3);
        free(r1);
        free(r2);
        free(r3);
    }
    /*while(fscanf(f, "%s%s%s%d", 
        pom1, p, pom2, &pom3) == 4)
    {
        n++;
        pesme = (pesma*)realloc(pesme, n * sizeof(pesma));
        if(pesme == NULL)
        {
            printf("Greska");
            exit(EXIT_FAILURE);
        }
        pom2[strlen(pom2) - 1] = 0;
        pesme[n - 1].brGledanja = pom3;
        pesme[n - 1].izvodjac 
            = (char*)malloc((strlen(pom1) + 1) * sizeof(char));
        pesme[n - 1].naslov 
            = (char*)malloc((strlen(pom2) + 1) * sizeof(char));
        if(pesme[n - 1].izvodjac == NULL
            || pesme[n - 1].naslov == NULL)
        {
            printf("Greska");
            exit(EXIT_FAILURE);            
        }
        strcpy(pesme[n - 1].izvodjac, pom1);
        strcpy(pesme[n - 1].naslov, pom2);
    }*/
    fclose(f);
    
    if(argc == 1)
    {
        tip = 'b';
    }
    else if(argc == 2)
    {
        tip = argv[1][1];
    }
    else
    {
        printf("greska");
    }
    
    qsort(pesme, n, sizeof(pesma), &poredi);
    
    for(i = 0; i < n; i++)
        printf("%s %s %d\n"
            , pesme[i].izvodjac
            , pesme[i].naslov
            , pesme[i].brGledanja);
    
    for(i = 0; i < n; i++)
    {
        free(pesme[i].izvodjac);
        free(pesme[i].naslov);
    }
    free(pesme);
    
    return 0;
}
